// Copyright (c) Microsoft Corporation. All rights reserved.

var http = require('http'),
    https = require('https'),
    url = require('url');

module.exports.attach = function (app) {
    app.all('/xhr_proxy', function proxyXHR(request, response) {
        var requestURL = url.parse(unescape(request.query.rurl));

        request.headers.host = requestURL.host;
        // fixes encoding issue
        delete request.headers['accept-encoding'];

        var options = {
            hostname: requestURL.hostname,
            path: requestURL.path,
            port: requestURL.port,
            method: request.method,
            headers: request.headers
        };

        var proxyCallback = function (proxyReponse) {
            proxyReponse.pipe(response);
        };
        
        var proxyRequest;

        if (requestURL.protocol === 'https:') {
            proxyRequest = https.request(options, proxyCallback);
        } else {
            proxyRequest = http.request(options, proxyCallback);
        }

        proxyRequest.on('error', function (err) {
            response.status(502).send(err.toString()).end();
        });
        proxyRequest.end();
    });
};
